<!DOCTYPE html>
<html>

<head lang="es">
	<meta charset="utf-8">
	<title>Trabajo en grupo TG2</title>
	<link rel="stylesheet" href="style.css">
	<style>
		table,
		th,
		td {
			border: 1px solid black;
		}
	</style>
</head>

<body>
	<header>
		<h1>Desarrollo con Tecnologias Emergentes. Curso 2019-20<br>
			Trabajo TG2 del grupo T2<br>
			Titulo: TG2. Evaluar y comparar dos tecnologias emergentes</h1>
	</header>
	<nav>
		<ul>
			<li><a href="#1">1. Informacion general</a></li>
			<li><a href="#2">2. Descripcion de las tecnologias</a></li>
			<li><a href="#3">3. Criterios de comparacion</a></li>
			<li><a href="#4">4. Evaluacion de los criterios por categoria</a></li>
			<li><a href="#5">5. Comparacion de las tecnologias</a></li>
			<li><a href="#6">6. Recomendaciones</a></li>
		</ul>
	</nav>

	<main>
		<section id=1">
			<h2>1. Informacion general</h2>
			<h3>1.1 Autores</h3>
			<p>Grupo T2:</p>
				<p>Sergio Moreno Solera(Product Owner)</p>
				<p>Carlos Martínez Álvarez</p>
				<p>Miguel Galán Tabernero</p>
				<p>Joaquín Garín Garzón</p>
				<p>Aarón Jiménez Herráez</p>
			<h3>1.2 Proyecto Scrum y repositorio en GitLab</h3>
			<p>La URL del proyecto "TG2" del grupo T2 en GitLab del grupo:
				<a href="https://gitlab.com/dte2020/t2/tg2/">https://gitlab.com/dte2020/t2/tg2/</a>.</p>
			<h3>1.3 Burndown chart</h3>
			<img src="burndown.jpg">
			<h3>1.4 Presentación del trabajo</h3>
			<p>En este apartado se debe incluir el enlace al archivo de la presentación con diapositivas, ubicado en el
				repositorio del proyecto.</p>
			<a href="T2-TG2.pptx">Presentación con diapositivas del trabajo TG1</a></p>
		</section>

		<section id="2">
			<h2>2. Descripcion de las tecnologias</h2>
			<h3>2.1 Descripcion de Amazon Neptune</h3>
			<p>Amazon Neptune es un servicio de bases de datos de gráficos, que forma parte de la tecnología Amazon Web Service. Es un servicio completamente administrado que permite ejecutar fácilmente aplicaciones que funcionan con un conjunto de datos altamente conectados.
				El núcleo de Amazon Neptune es un motor de bases de datos gráficos de alto desempeño diseñado expresamente para almacenar miles de millones de relaciones y consultar los gráficos con una latencia de milisegundos.
				Amazon Neptune admite los modelos de gráficos populares Property Graph y RDF del W3C, así como sus lenguajes de consulta asociados Apache TinkerPop Gremlin y SPARQL, lo que le permite crear fácilmente consultas.
				Amazon Neptune ofrece alta disponibilidad, con réplicas de lectura, recuperación a un momento dado, copias de seguridad continuas en Amazon S3 y replicación entre zonas de disponibilidad. Neptune resulta seguro gracias al soporte para conexiones HTTPS de cliente cifradas y al cifrado en reposo.</p>
				<p><a href="https://aws.amazon.com/es/neptune/">Enlace web a la informacion</a></p>
				
			<h3>2.2 Descripcion de Neo4j</h3>
			<p>Neo4J es una base de datos de gráficos nativa diseñada específicamente para aprovechar tanto los datos como las relaciones entre ellos. Se dice que es una base de datos de gráficos nativa debido a que su capa de almacenamiento nativa es un grafo conectado.
				Neo4 está implementada en Java y utiliza un grafo de propiedades etiquetado para el almacenamiento de los datos. En un grafo de propiedades etiquetado, los nodos se representan con unas etiquetas que permiten clasificar a los distintos nodos del árbol. Tanto nodos como relaciones se caracterizan por una serie de propiedades, en cuyos valores se alacena la información del grafo.
				Neo4j proporciona un lenguaje específico para la realización de consultas sobre el grafo conocido como Cypher. Además, dispone de una API REST que permite consultar y modificar los datos de la base de datos mediante peticiones HTTP.
				Entre las principales características de Neo4j podemos destacar:
				·      Soporta transacciones ACID
				·      Posibilidad de definir índices sobre las propiedades de los nodos
				·      Alta disponibilidad, balanceo de carga de lectura.
				·      Independientemente del tamaño de la red, la velocidad de las operaciones es constante.</p>
				<p><a href="https://neo4j.com/neo4j-graph-database/">Enlace web a la informacion</a></p>
		</section>
		<section id="3">
			<h2>3. Criterios de comparacion</h2>

			<h3>3.1 Categoria A: General</h3>
			<h4>3.1.1 Criterio A.1: Autor/Desarrollador</h4>
			<ul>
				<li>Nombre del criterio: Autor/Desarrollador.</li>
				<li>Descripcion: Nombre de la persona, institución o empresa que ha creado la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.1.2 Criterio A.2: Económico</h4>
			<ul>
				<li>Nombre del criterio: Precio.</li>
				<li>Descripcion: Cantidad o precio a pagar para utilizar u obtener la herramienta.</li>
				<li>Tipo de valor: Numérico.</li>
			</ul>
			<h4>3.1.3 Criterio A.3: Lenguaje de programación</h4>
			<ul>
				<li>Nombre del criterio: Lenguaje de programación.</li>
				<li>Descripcion: Indica el lenguaje de programación en el que está escrita la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.1.4 Criterio A.4: Popularidad</h4>
			<ul>
				<li>Nombre del criterio: Popularidad de la herramienta.</li>
				<li>Descripcion: Establece un valor(1-10) para la herramienta en función de sus posición con respecto a la competencia.</li>
				<li>Tipo de valor: Numérico.</li>
			</ul>
			<h4>3.1.5 Criterio A.5: Actualización</h4>
			<ul>
				<li>Nombre del criterio: Versiones estables.</li>
				<li>Descripcion: Disponibilidad de una versión estable y disponibilidad de actualizaciones que mejoran la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.1.6 Criterio A.6: Licencia</h4>
			<ul>
				<li>Nombre del criterio: Licencia.</li>
				<li>Descripcion: tipo de licencia de software necesario para utilizar la herramienta(open source, apache software, etc).</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h3>3.2 Categoria B: Características</h3>
			<h4>3.2.1 Criterio B.1: Leguajes soportados</h4>
			<ul>
				<li>Nombre del criterio: Lenguajes de programación soportados.</li>
				<li>Descripcion: lenguajes de programación que es capaz de soportar la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.2.2 Criterio B.2: Transaccional</h4>
			<ul>
				<li>Nombre del criterio: Transacciones.</li>
				<li>Descripcion: Indica si se considera un sistema transaccional(ACID).</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.2.3 Criterio B.3: Almacenamiento</h4>
			<ul>
				<li>Nombre del criterio: Modelo de almacenamiento.</li>
				<li>Descripcion: Este criterio se refiere al método utilizado por la base de datos para almacenar, manipular y organizar los datos.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h3>3.3 Categoria C: Rendimiento</h3>
			<h4>3.3.1 Criterio C.1: Sincronización</h4>
			<ul>
				<li>Nombre del criterio: Sincronizar datos.</li>
				<li>Descripcion: Es posible sincronizar los datos con otro servidor.</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.3.2 Criterio C.2: Limitación</h4>
			<ul>
				<li>Nombre del criterio: Limitaciones de la herramienta.</li>
				<li>Descripcion: Determina el número máximo de nodos, relaciones o ciertas limitaciones claves.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.3.3 Criterio C.3: Seguridad</h4>
			<ul>
				<li>Nombre del criterio: Recuperación de datos.</li>
				<li>Descripcion: Tiene medidas que aseguran la recuperación de datos en caso de fallo o desastre.</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.3.4 Criterio C.4: Back up</h4>
			<ul>
				<li>Nombre del criterio: Back up.</li>
				<li>Descripcion:  Capacidad de realizar back up(semanales, diarios, etc).</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h3>3.4 Categoria D: Usabilidad</h3>
			<h4>3.4.1 Criterio D.1: Integración</h4>
			<ul>
				<li>Nombre del criterio: Integración.</li>
				<li>Descripcion: Describe si se puede o no integrar con otras aplicaciones o la capacidad que tiene para integrarse.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.4.2 Criterio D.2: Lenguajes consulta</h4>
			<ul>
				<li>Nombre del criterio: Lenguajes de consulta.</li>
				<li>Descripcion: Lenguaje/s para realizar consultas en la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.4.3 Criterio D.3: Instalación</h4>
			<ul>
				<li>Nombre del criterio: Instalación.</li>
				<li>Descripcion: Dificultad del proceso de instalación.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.4.4 Criterio D.4: Windows</h4>
			<ul>
				<li>Nombre del criterio: Disponibilidad en Windows.</li>
				<li>Descripcion: Indica si la aplicación tiene disponibilidad en el sistema operativo.</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.4.5 Criterio D.5: Linux</h4>
			<ul>
				<li>Nombre del criterio: Disponibilidad en Linux.</li>
				<li>Descripcion: Indica si la aplicación tiene disponibilidad en el sistema operativo.</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.4.6 Criterio D.6: MAC</h4>
			<ul>
				<li>Nombre del criterio: Disponibilidad en MAC.</li>
				<li>Descripcion: Indica si la aplicación tiene disponibilidad en el sistema operativo.</li>
				<li>Tipo de valor: Boolean.</li>
			</ul>
			<h4>3.4.7 Criterio D.7: Requisitos</h4>
			<ul>
				<li>Nombre del criterio: Requisitos mínimos.</li>
				<li>Descripcion: Requisitos mínimos de hardware para usar la aplicación.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h3>3.5 Categoria E: Ayudas</h3>
			<h4>3.5.1 Criterio E.1: Soporte</h4>
			<ul>
				<li>Nombre del criterio: Soporte técnico.</li>
				<li>Descripcion: Soporte sobre ayudas para el uso de la aplicación o consulta de errores.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.5.2 Criterio E.2: Documentación</h4>
			<ul>
				<li>Nombre del criterio: Manual.</li>
				<li>Descripcion: Manual de uso o guía oficial de la aplicación(Comprensibilidad, claridad, estructura, contenido, etc).</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
			<h4>3.5.3 Criterio E.3: Información</h4>
			<ul>
				<li>Nombre del criterio: Información disponible de la herramienta.</li>
				<li>Descripcion: Indica la cantidad de información disponible acerca de la herramienta.</li>
				<li>Tipo de valor: Texto libre.</li>
			</ul>
		</section>

		<section id="4">
			<h2>4. Evaluación de los criterios por categoría</h2>
			<h3>4.1 Evaluación de los criterios para la Tecnología 1: Amazon Neptune</h3>
			<table>
			<tr>
			<th>Categoria A: General</th>
			<th>Criterios generales sobre Amazon Neptune </th>
			</tr>
			<tr>
			<td>Criterio A.1: Autor/Desarrollador</td>
			<td>Está desarrollado por los servicios web de Amazon. Es una herramienta que forma parte de los servicios web de Amazon en el ámbito del graph database. </td>
			</tr>
			<tr>
			<td>Criterio A.2: Económico</td>
			<td><p>-db.r5.large:	0,402 USD por hora</p>
				<p>-db.r5.xlarge:  	0,804 USD por hora</p>
				<p>-db.r5.2xlarge:	1,608 USD por hora</p>
				<p>-db.r5.4xlarge:	3,216 USD por hora</p>
				<p>-db.r5.8xlarge:	6,456 USD por hora</p>
				<p>-db.r5.12xlarge:	9,648 USD por hora </p></td>
			</tr>
			<tr>
			<td>Criterio A.3: Lenguaje de programación</td>
			<td>N/D</td>
			</tr>
			<tr>
			<td>Criterio A.4: Popularidad</td>
			<td>6 </td>
			</tr>
			<tr>
			<td>Criterio A.5: Actualización</td>
			<td>Amazon da soporte a millones de empresas con sus AWS, por lo que las actualizaciones de sus productos están siempre al día y en constante evolución. </td>
			</tr>
			<tr>
			<td>Criterio A.6: Licencia</td>
			<td>Amazon Neptune admite API de Open Graph tanto para Gremlin como para SPARQL y, además, le brinda un alto desempeño en ambos modelos de gráficos y en sus respectivos lenguajes de consulta. </td>
			</tr>
			<tr>
			<th>Categoria B: Características</th>
			<th>Evaluacion</th>
			</tr>
			<tr>
			<td>Criterio B.1: Lenguajes soportados</td>
			<td>N/D</td>
			</tr>
			<tr>
			<td>Criterio B.2: Transaccional</td>
			<td>Si </td>
			</tr>
			<tr>
			<td>Criterio B.3: Almacenamiento</td>
			<td>Se encuentra un almacenamiento tolerante a errores y de recuperación automática creado para la nube que replica sus datos en seis copias, distribuidas en tres zonas de disponibilidad. Property Graph </td>
			</tr>
			<tr>
			<th>Categoria C: Rendimiento</th>
			<th></th>
			</tr>
			<tr>
			<td>Criterio C.1: Sincronización</td>
			<td>Si</td>
			</tr>
			<tr>
			<td>Criterio C.2: Limitación</td>
			<td>El límite mínimo de almacenamiento es de 10 GB. El almacenamiento de Amazon Neptune aumentará automáticamente en función del uso de la base de datos hasta 64 TB en incrementos de 10 GB, sin que ello afecte al rendimiento de la base de datos. No es necesario aprovisionar el almacenamiento de antemano. </td>
			</tr>
			<tr>
			<td>Criterio C.3: Seguridad</td>
			<td>Si</td>
			</tr>
			<tr>
			<td>Criterio C.4: Back up</td>
			<td>Neptune realiza constantemente copias de seguridad de sus datos en Amazon S3 y se recupera de errores en el almacenamiento físico de forma transparente. </td>
			</tr>
			<tr>
			<th>Categoria D: Usabilidad</th>
			<th>Evaluacion</th>
			</tr>
			<tr>
			<td>Criterio D.1: Integración</td>
			<td>Compatibilidad con Gremlin de Apache TinkerPop para gráficos de propiedades y compatibilidad con el marco de descripción de recursos (RDF) 1.1 de W3C y SPARQL 1.1 </td>
			</tr>
			<tr>
			<td>Criterio D.2: Lenguajes consulta</td>
			<td>Amazon Neptune soporta tanto el lenguaje de código abierto de recorrido de gráficos Gremlin de Apache TinkerPop como el lenguaje de consulta SPARQL del marco de descripción de recursos (RDF) estándar de W3C.</td>
			</tr>
			<tr>
			<td>Criterio D.3: Instalación</td>
			<td>Sólo necesita la instalación de una serie de consolas y configuraciones, algunos de estos son: Configurar la consola de Gremlin para conectarse a una instancia de base de datos de Neptune o uso de Java o Python para conectarse a Neptune.  </td>
			</tr>
			<tr>
			<td>Criterio D.4: Windows</td>
			<td>Si</td>
			</tr>
			<tr>
			<td>Criterio D.5: Linux</td>
			<td>Si</td>
			</tr>
			<tr>
			<td>Criterio D.6: MAC</td>
			<td>Si</td>
			</tr>
			<tr>
			<td>Criterio D.7: Requisitos</td>
			<td>Los requisitos previos son tener un ordenador con conexión a internet y tener instalados las consolas y ajustes que hemos mencionado anteriormente. </td>
			</tr>
			<tr>
			<th>Categoria E: Ayudas</th>
			<th>Evaluacion</th>
			</tr>
			<tr>
			<td>Criterio E.1: Soporte </td>
			<td>Neptune es un servicio completamente administrado, por lo que ya no debe preocuparse por las tareas de administración de la base de datos, como el aprovisionamiento de hardware, la aplicación de parches de software, la instalación, la configuración o las copias de seguridad. </td>
			</tr>
			<tr>
			<td>Criterio E.2: Documentación </td>
			<td>Existe una guía de usuario que nos puede servir para configurar Amazon Neptune a nuestro gusto y aprender cómo funciona. </td>
			</tr>
			<tr>
			<td>Criterio E.3: Información </td>
			<td>Podemos encontrar una amplia variedad de datos referentes a este servicio, tanto en su página web como en páginas especializadas en ver el rendimiento de las diferentes opciones que tienen los usuarios y las empresas en el ámbito del graph database. </td>
			</tr>
			</table>
			<p><a href="https://aws.amazon.com/es/neptune/pricing/">Enlace web de precios</a></p>
			<p><a href="https://db-engines.com/en/ranking/graph+dbms">Enlace web de ranking DBMS</a></p>
			<p><a href="https://docs.aws.amazon.com/es_es/neptune/latest/userguide/neptune-ug.pdf">Enlace del manual de uso</a></p>


			<h3>4.2 Evaluacion de los criterios para la tecnologia 2: Neo4j</h3>
			<table>
				<tr>
				<th>Categoria A: General</th>
				<th>Criterios generales sobre Neo4j </th>
				</tr>
				<tr>
				<td>Criterio A.1: Autor/Desarrollador</td>
				<td>Emil Eifren - CEO y Cofundador.</td>
				</tr>
				<tr>
				<td>Criterio A.2: Económico</td>
				<td>0€.</td>
				</tr>
				<tr>
				<td>Criterio A.3: Lenguaje de programación</td>
				<td>Java.</td>
				</tr>
				<tr>
				<td>Criterio A.4: Popularidad</td>
				<td>9 (Open Source). </td>
				</tr>
				<tr>
				<td>Criterio A.5: Actualización</td>
				<td>Neo4j 4.0.3 - última versión estable.</td>
				</tr>
				<tr>
				<td>Criterio A.6: Licencia</td>
				<td>Open Source - Licencia dual: AGPLv3 / comercial.</td>
				</tr>
				<tr>
				<th>Categoria B: Características</th>
				<th>Evaluacion</th>
				</tr>
				<tr>
				<td>Criterio B.1: Lenguajes soportados</td>
				<td>Java, JavaScript, Python, Net, Ruby, PHP, Perl, Scala, Go, Clojure, Groovy.</td>
				</tr>
				<tr>
				<td>Criterio B.2: Transaccional</td>
				<td>Si </td>
				</tr>
				<tr>
				<td>Criterio B.3: Almacenamiento</td>
				<td>Graph DBMS.</td>
				</tr>
				<tr>
				<th>Categoria C: Rendimiento</th>
				<th>Evaluación</th>
				</tr>
				<tr>
				<td>Criterio C.1: Sincronización</td>
				<td>Si</td>
				</tr>
				<tr>
				<td>Criterio C.2: Limitación</td>
				<td>Límite máximo: supera los 34.000 millones de nodos (datos), 34.000 millones de relaciones entre esos datos.</td>
				</tr>
				<tr>
				<td>Criterio C.3: Seguridad</td>
				<td>Si</td>
				</tr>
				<tr>
				<td>Criterio C.4: Back up</td>
				<td>Realiza constantemente copias de segurridad, tanto de manera Online como Offline. </td>
				</tr>
				<tr>
				<th>Categoria D: Usabilidad</th>
				<th>Evaluacion</th>
				</tr>
				<tr>
				<td>Criterio D.1: Integración</td>
				<td>Se integra perfectamente con otros lenguajes como Java, PHP, etc. Efectúa las consultas directamente desde un API Rest, lo que hace interesante su integración con otras aplicaciones web.</td>
				</tr>
				<tr>
				<td>Criterio D.2: Lenguajes consulta</td>
				<td>Cypher: lenguaje de consulta propio.</td>
				</tr>
				<tr>
				<td>Criterio D.3: Instalación</td>
				<td>No requiere de mucha dificultad, se pude hacer desde la página web oficial, donde encontraremos una guía para completar el proceso.</td>
				</tr>
				<tr>
				<td>Criterio D.4: Windows</td>
				<td>Si</td>
				</tr>
				<tr>
				<td>Criterio D.5: Linux</td>
				<td>Si</td>
				</tr>
				<tr>
				<td>Criterio D.6: MAC</td>
				<td>Si</td>
				</tr>
				<tr>
				<td>Criterio D.7: Requisitos</td>
				<td>El rendimiento está vinculado a la memoria o a E/S, ligado a grandes grafos (CPU). El aumento de memoria permite realizar grafos más grandes (memoria).</td>
				</tr>
				<tr>
				<th>Categoria E: Ayudas</th>
				<th>Evaluacion</th>
				</tr>
				<tr>
				<td>Criterio E.1: Soporte </td>
				<td>Podremos encontrar el soporte técnico necesario en la página web de la aplicación: preguntas frecuentes, cursos sobre el producto, teléfono de contacto...</td>
				</tr>
				<tr>
				<td>Criterio E.2: Documentación </td>
				<td>Guía de usuario y documentación oficial en la página web. </td>
				</tr>
				<tr>
				<td>Criterio E.3: Información </td>
				<td>Podemos encontrar toda la información necesaria sobre este servicio tanto en su página web como en páginas especializadas en informarse sobre el ámbito GDB. </td>
				</tr>
				</table>

		</section>

		<section id="5">
			<h2>5. Comparacion de las tecnologias</h2>
				<table>
					<tr>
						<th>Criterio</th>
						<th>Amazon Neptune</th>
						<th>Neo4j</th>
						<th>Comentarios</th>
	
					</tr>
					<tr>
						<td>A.1</td>
						<td>Está desarrollado por los servicios web de Amazon. Es una herramienta que forma parte de los servicios web de Amazon en el ámbito del graph database.</td>
						<td>Emil Eifren - CEO y Cofundador.</td>
						<td>Destacar que ne Neo4j se destaca a su ceo y cofundador como principal autor y desarrollador del proyecto, mientras que en neptune no se destaca a nadie en concreto</td>
					</tr>
					<tr>
						<td>A.2</td>
						<td><p>-db.r5.large:	0,402 USD por hora</p>
							<p>-db.r5.xlarge:  	0,804 USD por hora</p>
							<p>-db.r5.2xlarge:	1,608 USD por hora</p>
							<p>-db.r5.4xlarge:	3,216 USD por hora</p>
							<p>-db.r5.8xlarge:	6,456 USD por hora</p>
							<p>-db.r5.12xlarge:	9,648 USD por hora </p></td>
						<td>0€.</td>
						<td>En cuanto a este criterio es preferible Neo4j ya que es gratuito a diferencia de Neptune</td>
					</tr>
					<tr>
						<td>A.3</td>
						<td>N/D</td>
						<td>Java</td>
						<td>En Neo4j se usa Java</td>
					</tr>
					<tr>
						<td>A.4</td>
						<td>6</td>
						<td>9 (Open Source).</td>
						<td>Está claramente mejor posicionado Neo4j ya que su nota es mayor</td>
					</tr>
					<tr>
						<td>A.5</td>
						<td>Amazon da soporte a millones de empresas con sus AWS, por lo que las actualizaciones de sus productos están siempre al día y en constante evolución.</td>
						<td>Neo4j 4.0.3 - última versión estable.</td>
						<td>Amazon Neptune cuenta con un soporte que actualiza de manera mas constante la versión</td>
					</tr>
					<tr>
						<td>A.6</td>
						<td>Amazon Neptune admite API de Open Graph tanto para Gremlin como para SPARQL y, además, le brinda un alto desempeño en ambos modelos de gráficos y en sus respectivos lenguajes de consulta.</td>
						<td>Open Source - Licencia dual: AGPLv3 / comercial.</td>
						<td>Destacar Amazon Neptune ya que admite una gama de licencias de software mas amplia que Neo4j</td>
					</tr>
					<tr>
						<td>B.1</td>
						<td>N/D</td>
						<td>Java, JavaScript, Python, Net, Ruby, PHP, Perl, Scala, Go, Clojure, Groovy.</td>
						<td>Neo4j soporta una amplia variedad de lenguajes de programación</td>
					</tr>
					<tr>
						<td>B.2</td>
						<td>Si</td>
						<td>Si</td>
						<td>Ambos dos son sistemas transaccionales</td>
					</tr>
					<tr>
						<td>B.3</td>
						<td>Se encuentra un almacenamiento tolerante a errores y de recuperación automática creado para la nube que replica sus datos en seis copias, distribuidas en tres zonas de disponibilidad. Property Graph </td>
						<td>Graph DBMS.</td>
						<td>Amazon Neptune destaca sobre Neo4j ya que es un sistema similar pero con mayor tolerancia a errores y recuperación automatica</td>
					</tr>
					<tr>
						<td>C.1</td>
						<td>Si</td>
						<td>Si</td>
						<td>En ambos dos se pueden sincronizar datos con otros servidores</td>
					</tr>
					<tr>
						<td>C.2</td>
						<td>El límite mínimo de almacenamiento es de 10 GB. El almacenamiento de Amazon Neptune aumentará automáticamente en función del uso de la base de datos hasta 64 TB en incrementos de 10 GB, sin que ello afecte al rendimiento de la base de datos. No es necesario aprovisionar el almacenamiento de antemano.</td>
						<td>Límite máximo: supera los 34.000 millones de nodos (datos), 34.000 millones de relaciones entre esos datos.</td>
						<td>Ambos dos cuentan con unas limitaciones maximas similares pero Neptune cuenta ademas con limitaciones minimas de almacenamiento</td>
					</tr>
					<tr>
						<td>C.3</td>
						<td>Si</td>
						<td>Si</td>
						<td>Los dos cuentan con las medidas de seguridad pertinentes</td>
					</tr>
					<tr>
						<td>C.4</td>
						<td>Neptune realiza constantemente copias de seguridad de sus datos en Amazon S3 y se recupera de errores en el almacenamiento físico de forma transparente. </td>
						<td>Realiza constantemente copias de segurridad, tanto de manera Online como Offline. </td>
						<td>Los dos realizan copias de seguridad de manera constante peor Neo4j las realiza tanto de forma online como offline</td>
					</tr>
					<tr>
						<td>D.1</td>
						<td>Compatibilidad con Gremlin de Apache TinkerPop para gráficos de propiedades y compatibilidad con el marco de descripción de recursos (RDF) 1.1 de W3C y SPARQL 1.1 </td>
						<td>Se integra perfectamente con otros lenguajes como Java, PHP, etc. Efectúa las consultas directamente desde un API Rest, lo que hace interesante su integración con otras aplicaciones web.</td>
						<td>Mientras que Amazon Neptune consta con mayores limitaciones en cuanto a integrarse con otras aplicaciones Neo4j se integra perfectamente con una amplia variedad de aplicaciones</td>
					</tr>
					<tr>
						<td>D.2</td>
						<td>Amazon Neptune soporta tanto el lenguaje de código abierto de recorrido de gráficos Gremlin de Apache TinkerPop como el lenguaje de consulta SPARQL del marco de descripción de recursos (RDF) estándar de W3C.</td>
						<td>Cypher: lenguaje de consulta propio.</td>
						<td>Amazon Neptune soporta masa lenguajes para la realización de consultas que Neo4j</td>
					</tr>
					<tr>
						<td>D.3</td>
						<td>Sólo necesita la instalación de una serie de consolas y configuraciones, algunos de estos son: Configurar la consola de Gremlin para conectarse a una instancia de base de datos de Neptune o uso de Java o Python para conectarse a Neptune.  </td>
						<td>No requiere de mucha dificultad, se pude hacer desde la página web oficial, donde encontraremos una guía para completar el proceso.</td>
						<td>Neo4j cuenta con una instalacion mas sencilla y mejor explicada que Amazon</td>
					</tr>
					<tr>
						<td>D.4</td>
						<td>Si</td>
						<td>Si</td>
						<td>Los dos son compatibles con el Windows</td>
					</tr>
					<tr>
						<td>D.5</td>
						<td>Si</td>
						<td>Si</td>
						<td>Los dos son compatibles con el Linux</td>
					</tr>
					<tr>
						<td>D.6</td>
						<td>Si</td>
						<td>Si</td>
						<td>Los dos son compatibles con el MAC</td>
					</tr>
					<tr>
						<td>D.7</td>
						<td>Los requisitos previos son tener un ordenador con conexión a internet y tener instalados las consolas y ajustes que hemos mencionado anteriormente. </td>
						<td>El rendimiento está vinculado a la memoria o a E/S, ligado a grandes grafos (CPU). El aumento de memoria permite realizar grafos más grandes (memoria).</td>
						<td>Los dos tienen unos requisitos minimos similares en cuanto a hardware se refiere</td>
					</tr>
					<tr>
						<td>E.1</td>
						<td>Neptune es un servicio completamente administrado, por lo que ya no debe preocuparse por las tareas de administración de la base de datos, como el aprovisionamiento de hardware, la aplicación de parches de software, la instalación, la configuración o las copias de seguridad. </td>
						<td>Podremos encontrar el soporte técnico necesario en la página web de la aplicación: preguntas frecuentes, cursos sobre el producto, teléfono de contacto...</td>
						<td>Neptune no necesita que el usuario tenga acceso al soporte tecnico ya que ellos gestionan la base de datos mientras que Neo4j si que facilita ese soporte</td>
					</tr>
					<tr>
						<td>E.2</td>
						<td>Existe una guía de usuario que nos puede servir para configurar Amazon Neptune a nuestro gusto y aprender cómo funciona. </td>
						<td>Guía de usuario y documentación oficial en la página web. </td>
						<td>Ambos dos tienen una Guia de facil acceso y que explica de manera bastante concisa como manejar los software</td>
					</tr>
					<tr>
						<td>E.3</td>
						<td>Podemos encontrar una amplia variedad de datos referentes a este servicio, tanto en su página web como en páginas especializadas en ver el rendimiento de las diferentes opciones que tienen los usuarios y las empresas en el ámbito del graph database. </td>
						<td>Podemos encontrar toda la información necesaria sobre este servicio tanto en su página web como en páginas especializadas en informarse sobre el ámbito GDB. </td>
						<td>En ambo caso hay suficiente informacion sobre los software pero de acceso mas sencillo y rapido en el caso de Neo4j</td>
					</tr>
	
	
				</table>
		</section>

		<section id="6">
			<h2>6. Recomendaciones</h2>
			<p></p>
			<h3>6.1 Situacion A</h3>
			<h4>6.1.1 Descripcion de la situacion</h4>
			<p>Se trata de el departamento de SI de un importante banco que ha decidido cambiar su base de datos a una base de datos orientada a grafos, 
				es muy importante la seguridad de esta información y cuentan con profesionales expertos en diversos lenguajes de consulta. 
				El presupuesto no es problema para el banco, estan dispuestos a realizar una gran inversión, pero quieren asegurar que no puede haber ninguna perdida de informacion</p>
			<h4>6.1.2 Recomendacion de la tecnología a utilizar</h4>
			<p>La tecnologia propuesta es Amazon Neptune</p>
			<p></p>
			<p></p>
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas Amazon Neptune</th>
					<th>Ventajas Neo4j</th>
				</tr>
				<tr>
					<td>A.5</td>
					<td>Amazon da soporte a millones de empresas con sus AWS, por lo que las actualizaciones de sus productos están siempre al día y en constante evolución.</td>
					<td>Amazon Neptune aporta mayor fiabilidad ya que actualiza sus versiones de manera mas constante que Neo4J</td>
				</tr>
				<tr>
					<td>A.6</td>
					<td>Amazon Neptune admite API de Open Graph tanto para Gremlin como para SPARQL y, además, le brinda un alto desempeño en ambos modelos de gráficos y en sus respectivos lenguajes de consulta.</td>
					<td>Open Source - Licencia dual: AGPLv3 / comercial.</td>
					<td>Nos interesa mas Amazon Neptune ya que admite una gama de licencias de software mas amplia que Neo4j</td>
				</tr>
				<tr>
					<td>B.3</td>
					<td>Se encuentra un almacenamiento tolerante a errores y de recuperación automática creado para la nube que replica sus datos en seis copias, distribuidas en tres zonas de disponibilidad. Property Graph </td>
					<td>Graph DBMS.</td>
					<td>Amazon Neptune destaca sobre Neo4j ya que es un sistema similar pero con mayor tolerancia a errores y recuperación automatica y este es uno de los apartados que mas puede interesar al banco ya que es crucial no perder nada de informacion</td>
				</tr>
				<tr>
					<td>D.2</td>
					<td>Amazon Neptune soporta tanto el lenguaje de código abierto de recorrido de gráficos Gremlin de Apache TinkerPop como el lenguaje de consulta SPARQL del marco de descripción de recursos (RDF) estándar de W3C.</td>
					<td>Cypher: lenguaje de consulta propio.</td>
					<td>Amazon Neptune soporta masa lenguajes para la realización de consultas que Neo4j</td>
				</tr>
				<tr>
					<td>E.1</td>
					<td>Neptune es un servicio completamente administrado, por lo que ya no debe preocuparse por las tareas de administración de la base de datos, como el aprovisionamiento de hardware, la aplicación de parches de software, la instalación, la configuración o las copias de seguridad. </td>
					<td>Podremos encontrar el soporte técnico necesario en la página web de la aplicación: preguntas frecuentes, cursos sobre el producto, teléfono de contacto...</td>
					<td>Neptune no necesita que el usuario tenga acceso al soporte tecnico ya que ellos gestionan la base de datos mientras que Neo4j si que facilita ese soporte, esto es bueno para la empresa ya que no tiene que encargarse de contactar con soportes tecnicos.</td>
				</tr>
			</table>

			<h3>6.2 Situacion B</h3>
			<h4>6.2.1 Descripcion de la situacion</h4>
			<p>Una empresa de mensajería en pleno desarrollo ha visto en el periodo de cuarentena la situación perfecta para incorporarse al mercado, debido al aumento de la demanda. Para ello, requiere del servicio de 
				una plataforma orientada a Graph DataBases, para la administración y gestión correcta de sus productos. Al tener un presupuesto escaso, recomiendan utilizar un software de código abierto (Open Source), 
				aunque podrían permitirse gastos no muy elevados. Además, necesitan que la plataforma trabaje en tiempo real, para poder localizar sus productos y envíos en todo momento.    </p>
			<h4>6.2.2 Recomendacion de la tecnología a utilizar</h4>
			<p>TECNOLOGÍA PROPUESTA: Neo4j.</p>
			
			<table>
				<tr>
					<th>Criterios relevantes para la decision</th>
					<th>Ventajas Amazon Neptune</th>
					<th>Ventajas Neo4j</th>
				</tr>
				<tr>
					<td>Criterio A.2: Económico</td>
					<td>Encontramos varias alternativas, la más barata por 0,402 USD/hora.</td>
					<td>Tecnología Open Source, totalmente gratuita.</td>
				</tr>
				<tr>
					<td>Criterio A.4: Popularidad</td>
					<td>No es de las mas conocidas en su sector (pop. = 6).</td>
					<td>Es de las más reconocidas en GDB, recomendada por sus clientes (pop. = 9).</td>
				</tr>
				<tr>
					<td>B.1: Lenguajes soportados</td>
					<td>N/D</td>
					<td>Neo4j soporta gran variedad de lenguajes, como Python, PHP, Java...</td>
				</tr>
				<tr>
					<td>Criterio B.2: Transaccional</td>
					<td>Sistema transaccional online, permite cargas de trabajo online (OLTP).</td>
					<td>Base de datos transaccional compatible con ACID.</td>
				</tr>
				<tr>
					<td>Criterio C.3: Seguridad</td>
					<td>Proporciona varios niveles de seguridad para su base de datos, como por ejemplo el cifrado de los datos de almacenamiento y copias de seguridad. </td>
					<td>Ofrece procesos de de autentificación y autorización, provee de extensiones de seguridad y garantiza la recuperación de datos.</td>
				</tr>
				<tr>
					<td>Criterio C.4: Back ups</td>
					<td>Realiza constantemente copias de seguridad de sus datos y se recupera de errores en el almacenamiento físico de forma transparente.</td>
					<td>Copias de seguridad constantes, tanto de manera online como offline.</td>
				</tr>
				<tr>
					<td>Criterio D.1: Integración</td>
					<td>Compatible con Gremlin y con el RDF 1.1 de W3C y SPARQL 1.1.</td>
					<td>Se integra perfectamente con otros lenguajes de programación, y efectua las consultas directamente desde un API Rest, lo que facilita su integración con otras apps. web.</td>
				</tr>
				<tr>
					<td>Criterio D.2: Lenguaje de consulta</td>
					<td>Soporta tanto el lenguaje de código abierto Gremlin como el lenguaje de consulta SPARQL. </td>
					<td>Posee un lenguaje de consulta propio, llamado Cypher.</td>
				</tr>
				<tr>
					<td>Criterio D.3: Instalación</td>
					<td>Necesita la instalación de una serie de consolas y configuraciones.</td>
					<td>No requiere de mucha dificultad desde la página web, donde encontramos una guía de ayuda.</td>
				</tr>
			</table>
		</section>


	</main>

</body>

</html>
